#!/bin/sh

pkg=$1
ver=$2
arch=$3
dist=$4
exitcode=0

mkdir -p "$dist"
cd "$dist" || exit 1

{{ rebuildd_upload_code_to_set_dput_profile }}

# Ensure HOME is set to the correct value
export HOME="{{ rebuildd_homedir }}"

# Drop epoch from version
ver_epoch=$ver
ver2=$(expr "$ver" : '[0-9]\+:\(.*\)')
if [ -n "$ver2" ]; then
    ver=$ver2
fi

jobfile="${pkg}_${ver}_${arch}.job"
if [ ! -e "$jobfile" ]; then
    echo "ERROR: job file $jobfile not found"
    exit 1
fi

changes_arch="${pkg}_${ver}_${arch}.changes"
changes_all="${pkg}_${ver}_all.changes"
if [ -e "$changes_arch" ]; then
    changes=$changes_arch
elif [ -e "$changes_all" ]; then
    changes=$changes_all
else
    echo "ERROR: changes file not found, tried: $changes_arch, $changes_all"
    exit 1
fi

# Remove buildinfo references from changes file (see #970720)
perl -i -ne 'print unless m/\.buildinfo/' "$changes"

# Sign and upload
if ! debsign "$changes"; then
    echo "ERROR: failed to sign $changes"
    exitcode=1
fi
try=0
while true; do
    try=$(( try + 1 ))
    if dput -U $dput_profile "$changes"; then
	break
    fi
    if [ $try -ge 3 ]; then
	echo "ERROR: failed to upload $changes after $try tries"
	exitcode=1
	break
    fi
    echo "WARNING: failed to upload $changes (try $try)"
    sleep 30
done

# Archive the build artifacts in the morgue directory
today=$(date +%Y%m%d)
morgue="{{ rebuildd_homedir }}/morgue"
dsc=$(cat "$jobfile")

echo "INFO: Archiving build in $morgue/$today/"
mkdir -p "$morgue/$today"
dcmd mv "$changes" "$morgue/$today"

# Drop the job file
rm -f "$jobfile"

# Remove the source package only if we have no other jobs using it
for job in "${pkg}_${ver}"_*.job; do
    if [ ! -e "$job" ]; then
	dcmd rm -f "$dsc"
    fi
done

exit $exitcode
